# Introduction

This is the ***ROOT*** folder for the unreal game project.

_NOTE - Unreal has blur enabled by default, disable this in project settings if you don't want blur._



# Adding UE5 Game Project

1. Open unreal, select a template, and create the project template anywhere.
2. Open the ***ROOT*** folder of the UE5 project you just created and copy `yourgame.uproject`, `Content`. `Config`, and `Source` into this folder.
3. If your `yourgame.uproject` file & `Content`. `Config`, `Source` folders are in the same directory as the repositories `.gitignore` file, then your setup is correct.

Once you've completed the above steps you're ready to open the project and start working.



# Opening The Project: For Programmers

If you're a programmer and plan on doing work in C++ you should right click the `yourgame.uproject` file and select the `Generate Visual Studio project files` option. When this is complete double click the `yourgame.sln` file and run the game from Visual Studio by clicking `Local Windows Debugger`. Whenever you code in C++ you should close UE5 and recompile it from VS.

If you are not doing anything in C++, then you can open the project straight from double clicking `yourgame.uproject`. Make sure you click yes on the prompt asking to compile. UE5 will take awhile to open because it's compiling C++ binaries in the background.

If UE5 is bing weird delete all the cache files/folders & generated files/folders, then lauch it from Visual Studio so it's forced to compile everything correctly and you will catch any compiler bugs if anything is wrong.



# Common Visual Studio/C++ Problems

### Too Much Unreal

If you are trying to run UE5 from Visual Studio, then close any other UE5 executable windows you have open. If Unreal is already running when you launch it from Visual Studio then it will sometimes prevent Visual Studio from being able to correctly compile your C++ files, which results in a compiler error.

To fix this close all open instances of Unreal Engine. Once you've done that everything will be fine and you should be able to run Unreal from Visual Studio.


### I'm getting an error with the build.bat in the Visual Studio error console

This happens when certain executables are already running in the background and haven't shutdown when they're meant to. To fix this open task manager and close `HUB for UE5 runtime traces...` and close every instance of `Runtime Broker` you can find.

Once you've done this, Visual Studio will work again and you can compile code.



# Fixing UE5 Setup

### dotnet is not recognized as an internal or external command

If you get an error similar to this one when generating visual studio project files or opening the project for the first time, it's because `.NET 6` is not installed or its environment path is not set.

To fix this locate `C:\program files\dotnet`, and delete the `dotnet` folder if it exists. If it doesn't exist, then don't do anything.

Next download the .NET 6 SDK ([.NET 6 download here](https://dotnet.microsoft.com/en-us/download/dotnet/6.0)) and install it. _(do not download `ASP.NET Core Runtime`, `.NET Desktop Runtime`, `.NET Runtime`, or any other SDK - just the plain `.NET 6` SDK that has everything included)_

This will fix the dotnet error.

### I don't know how to setup VS2022 for Unreal Engine 5

Follow this guide: [Setting Up Visual Studio Environment for C++](https://docs.unrealengine.com/5.1/en-US/setting-up-visual-studio-development-environment-for-cplusplus-projects-in-unreal-engine/)